/*
 *  Brno University of Technology
 *
 *  Copyright (C) 2009-2010 by Brno University of Technology and the contributors
 *
 *  Complete list of developers available at our web site:
 *
 *       http://spl.utko.feec.vutbr.cz
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/.
 */
package cz.vutbr.feec.utko.opencv.operators.imageProcessing;

import java.util.List;

import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.parameter.ParameterType;
import com.rapidminer.parameter.ParameterTypeCategory;

import static com.googlecode.javacv.cpp.opencv_core.*;
import static com.googlecode.javacv.cpp.opencv_imgproc.*;


public class MorphologicalTransformations extends BaseErodeDilate{
	
	private static final String TYPE_OF_MORPHOLOGICAL_OPERATION = "Morphological operation";
	private static final String[] TYPES_OF_MORPHOLOGICAL_OPERATION = new String[] {
		"Opening", 
		"Closing", 
		"Morphological gradient", 
		"Top hat",
		"Black hat" };
	
	public static final int MOP_OPEN = 0;
	public static final int MOP_CLOSE = 1;
	public static final int MOP_GRADIENT = 2;
	public static final int MOP_TOPHAT = 3;
	public static final int MOP_BLACKHAT = 4;
	
	public MorphologicalTransformations(OperatorDescription description) {
		super(description);
	}
	
	@Override
	public IplImage doWork(IplImage cvImg) throws OperatorException {
		IplImage out = cvCreateImage( cvGetSize(cvImg), IPL_DEPTH_8U, 3 );
		IplImage temp = null;
		
		int operation = 0;
		switch (getParameterAsInt(TYPE_OF_MORPHOLOGICAL_OPERATION)) {
		case MOP_OPEN:
			operation = CV_MOP_OPEN;
			break;
		case MOP_CLOSE:
			operation = CV_MOP_CLOSE;
			break;
		case MOP_GRADIENT:
			operation = CV_MOP_GRADIENT;
			temp = cvCreateImage( cvGetSize(cvImg), IPL_DEPTH_8U, 3 );
			break;
		case MOP_TOPHAT:
			operation = CV_MOP_TOPHAT;
			break;
		case MOP_BLACKHAT:
			operation = CV_MOP_BLACKHAT;
			break;

		default:
			break;
		}
		
		cvMorphologyEx(cvImg, out, temp, getKernel(), operation, getParameterAsInt(ITERATION_COUNT));
		
		return out;
		
	}
	
	@Override
	public List<ParameterType> getParameterTypes() {
		List<ParameterType> p = super.getParameterTypes();
		p.add(0, new ParameterTypeCategory(TYPE_OF_MORPHOLOGICAL_OPERATION,
				"Type of morphological operation",
				TYPES_OF_MORPHOLOGICAL_OPERATION, 0));
		
		return p;
	}

}
